const fs = require('fs')
const npmConf = require('npm-conf')
const file = npmConf().get('userconfig')
const user = require('../utils/user.js')

test('set a npm user from npmrc', async () => {
  let timestamp = new Date().toString()
  await user.set({ timestamp })
  
  let npmrcStr = fs.readFileSync(file, 'utf-8')

  expect(npmrcStr).toMatch(`timestamp=${timestamp}`)
})

test('get npm userinfo from npmrc', async () => {
  let timestamp = new Date().toString()
  await user.set({ timestamp })

  let userinfo = await user.get()
  expect(userinfo).toHaveProperty('timestamp', timestamp)

  let _timestamp = await user.get('timestamp')
  expect(_timestamp).toBe(timestamp)
})
