const fs = require('fs')
const extend = require('extend')
const { get } = require('lodash')
const { CHARSET, SPACE } = require('./CONFIG')

const charset = 'utf-8'

module.exports = function (file) {
  return {
    get (path = null) {
      const raw = JSON.parse(fs.readFileSync(file, CHARSET))
      return path ? get(raw, path) : raw
    },
    set (nobj = {}) {
      let oobj = JSON.parse(fs.readFileSync(file, CHARSET))

      extend(true, oobj, nobj)

      fs.writeFileSync(file, JSON.stringify(oobj, null, SPACE), CHARSET)
    }
  }
}