const RegClient = require('npm-registry-client')
const { REGISTRY } = require('../utils/CONFIG.js')

const client = new RegClient({})

// success: 201 -> 'success'
// error username or password: 403 -> 'error login'
// error email: 400 -> 'error email'
// null email: 400 -> 'null email'
// and more username/password validate
exports.login = async auth => {
  return new Promise((resolve, reject) => {
    client.adduser(REGISTRY, {
      auth: {
        alwaysAuth: false,
        ...auth
      }
    }, (error, data, raw, res) => {
      if (error) {
        if (error.statusCode === 403) {
          resolve({code: 403, msg: 'error login'})
        } else if (error.message === 'Please use a real email address.') {
          resolve({code: 400, msg: 'illegal email'})
        } else if (error.message === 'No email address supplied.') {
          resolve({code: 400, msg: 'null email'})
        } else {
          console.log(error)
          resolve(error)
        }
      } else {
        resolve({code: 201, msg: 'success'})
      }
    })
  })
}
