// npm用户信息
const fs = require('fs')
const npmConf = require('npm-conf')
const file = npmConf().get('userconfig')
const { parse, stringify } = require('ini')
const { CHARSET } = require('./CONFIG')

// registry will change
const getNpmrc = async function () {
  return parse(fs.readFileSync(file, CHARSET))
}

// user in privat register is save as:
// //xxx.xx.com/:username = xxx
const getPrefix = function (npmrc) {
  return (npmrc.registry || '').replace(/https:|http:/, '')
}

//not support remove: https://github.com/npm/ini/issues/15
exports.set = async function (user) {
  let npmrc = await getNpmrc()
  let prefix = getPrefix(npmrc)

  Object.keys(user).forEach(key => {
    let val = user[key]
    npmrc[`${prefix}:${key}`] = val
  })

  fs.writeFileSync(file, stringify(npmrc), CHARSET)
}

exports.get = async function (key = '') {
  let npmrc = await getNpmrc()
  let prefix = getPrefix(npmrc)
  let user = {}
  
  Object.keys(npmrc).forEach(key => {
    if (key.indexOf(prefix) !== -1) {
      let _key = key.replace(prefix + ':', '')
      user[_key] = npmrc[key]
    }
  })

  return key ? user[key] : user
}